package standardlib

import (
	odysseus "github.com/odysseus/odysseus-protocol/gen/proto/go/base/v1"
	"sync"
)

type StdLib interface {
	GenerateParam(difficult int) (string, error)
	VerifyResult(param string, result []byte) bool
}

var (
	standardLibMap = sync.Map{}
)

func RegisterStdLib(taskType uint64, lib StdLib) {
	standardLibMap.Store(taskType, lib)
}

func GetStdLib(taskType uint64) StdLib {
	if lib, ok := standardLibMap.Load(taskType); ok {
		return lib.(StdLib)
	}
	return nil
}

type StdTask struct {
	odysseus.TaskContent
}

func GetStdTaskList() []StdTask {
	return []StdTask{}
}
